=== debian/changelog ===
calamares (3.2.7-0ubuntu1) eoan; urgency=medium

  * New upstream release.
  * Remove patches applied in upstream code.
    - Remove drop re-parenting trickery patch.
    - Remove avoid heap-wrangling the CreatePartitionDialog patch.
    - Remove ensure the firmware type is set in the global configuration patch.
    - Remove restore button updates in partition page patch.
  * Bump debhelper version to >= 12.
  * Run wrap-and-sort.

 -- Dan Simmons <kc2bez@lubuntu.me>  Mon, 27 May 2019 19:51:59 -0400

calamares (3.2.4-0ubuntu3) disco; urgency=medium

  * Cherry-pick several beneficial upstream patches:
    - Ensure the firmware type is set in the global configuration.
    - Avoid heap-wrangling the CreatePartitionDialog.
    - Drop some re-parenting trickery.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 11 Apr 2019 12:41:55 -0500

calamares (3.2.4-0ubuntu2) disco; urgency=medium

  * Restore button updates in partition page (LP: #1823569).

 -- Dan Simmons <kc2bez@lubuntu.me>  Mon, 08 Apr 2019 07:18:07 -0400
